//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Client.CancellationTest.CancellationTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Wait For Cancel command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class WaitForCancelRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.IntegerDto _duration;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public WaitForCancelRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="duration">The time the server should wait for the cancellation</param>
        public WaitForCancelRequestDto(long duration, Tecan.Sila2.IBinaryStore store)
        {
            Duration = new Tecan.Sila2.IntegerDto(duration, store);
        }
        
        /// <summary>
        /// The time the server should wait for the cancellation
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto Duration
        {
            get
            {
                return _duration;
            }
            set
            {
                _duration = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/CancellationTest/v1/Command/WaitForCancel";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Duration, "duration");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Duration, "duration"));
        }
    }
}
